version: "3"

services:
  # PHP Service
  app:
    build:
      context: .
      dockerfile: ./docker/php/runtimes/php8.1/Dockerfile
    image: app-php
    container_name: app
    restart: unless-stopped
    tty: true
    environment:
      SERVICE_NAME: app
      SERVICE_TAGS: dev
    working_dir: /var/www
    volumes:
      - ./:/var/www
      - ./docker/php/local.ini:/usr/local/etc/php/conf.d/local.ini
    networks:
      - app-network

  # Nginx Service
  webserver:
    image: nginx:1.12
    container_name: webserver
    restart: unless-stopped
    tty: true
    ports:
      - "${APP_PORT:-80}:80"
    working_dir: /var/www
    volumes:
      - ./public:/var/www/public
      - ./docker/nginx/conf.d/:/etc/nginx/conf.d/
    networks:
      - app-network

  # MariaDB Service
  db:
    image: mariadb:10.5.11
    container_name: db
    restart: unless-stopped
    tty: true
    ports:
      - "${FORWARD_DB_PORT:-3306}:3306"
    environment:
      MYSQL_ROOT_PASSWORD: ${DB_PASSWORD}
      MYSQL_ROOT_HOST: "%"
      MYSQL_DATABASE: ${DB_DATABASE}
      MYSQL_USER: ${DB_USERNAME}
      MYSQL_PASSWORD: ${DB_PASSWORD}
      MYSQL_ALLOW_EMPTY_PASSWORD: 1
    volumes:
      - dbdata:/var/lib/mariadb
      - ./docker/mysql/my.cnf:/etc/mysql/my.cnf
    networks:
      - app-network
    healthcheck:
      test:
        - CMD
        - mysqladmin
        - ping
        - "-p${DB_PASSWORD}"
      retries: 3
      timeout: 5s

networks:
  app-network:
    driver: bridge

volumes:
  dbdata:
    driver: local
